//                                                                  
// Copyright  2006-2009 Lidor Systems.
// All Rights Reserved.
//
// This file is part of the "IntegralUI Lists" class Library. 
//                                                                   
// The contents of this file are subject to the IntegralUI TreeView
// License, and may not be used except in compliance with the License.
// A copy of the License should have been installed in the product's
// root installation directory or it can be found at
// http://www.lidorsystems.com/products/IntegralUI/agreement_treeview.aspx.
//                                                             
// This SOFTWARE is provided "AS IS", WITHOUT WARRANTY OF ANY KIND.
// either express or implied. See the License for the specific language 
// governing rights and limitations under the License.                        
//

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.IO;

using LidorSystems.IntegralUI.Style;
using LidorSystems.IntegralUI.Serialization;

namespace IntegralUITreeExplorer
{
	#region Form1 class
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		#region Variables
		private LidorSystems.IntegralUI.Lists.TreeView treeView1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.MenuItem menuItem15;
		private System.Windows.Forms.MenuItem mnuVisualStyle;
		private System.Windows.Forms.MenuItem mnuClassic;
		private System.Windows.Forms.MenuItem mnuXP;
		private System.Windows.Forms.MenuItem mnuVista;
		private System.Windows.Forms.MenuItem mnuThemed;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem mnuDragDrop;
		private System.Windows.Forms.ImageList smallImages;
		private System.Windows.Forms.ImageList treeNodeImages;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem menuItem10;
		private System.Windows.Forms.MenuItem menuItem12;
		private System.Windows.Forms.MenuItem mnuFading;
		private System.Windows.Forms.MenuItem mnuFadingDefault;
		private System.Windows.Forms.MenuItem mnuFadingOffice2007;
		private System.Windows.Forms.MenuItem menuItem13;
		private System.Windows.Forms.MenuItem menuItem14;
		private System.Windows.Forms.MenuItem menuItem16;
		private System.Windows.Forms.MenuItem menuItem17;
		private System.Windows.Forms.MenuItem menuItem18;
		private System.Windows.Forms.MenuItem menuItem19;
		private System.Windows.Forms.MenuItem menuItem21;
		private System.Windows.Forms.MenuItem mnuSelection;
		private System.Windows.Forms.MenuItem menuItem23;
		private System.Windows.Forms.MenuItem mnuSelectAll;
		private System.Windows.Forms.ImageList stateImages;
		private System.Windows.Forms.MenuItem mnuCheckBoxes;
		private System.Windows.Forms.MenuItem menuItem31;
		private System.Windows.Forms.MenuItem mnuEncoding;
		private System.Windows.Forms.MenuItem mnuAppearance;
		private System.Windows.Forms.MenuItem mnuExit;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.ImageList largeImages;
		private System.Windows.Forms.MenuItem mnuAllowSelCheck;
		private System.Windows.Forms.MenuItem mnuAllowEdit;
        private MenuItem mnuThreeState;
		private System.ComponentModel.IContainer components;
		#endregion

		#region Construction
		public Form1()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            LidorSystems.IntegralUI.Lists.Style.ListItemFormatStyle listItemFormatStyle1 = new LidorSystems.IntegralUI.Lists.Style.ListItemFormatStyle();
            LidorSystems.IntegralUI.Style.WatermarkImage watermarkImage1 = new LidorSystems.IntegralUI.Style.WatermarkImage();
            this.smallImages = new System.Windows.Forms.ImageList(this.components);
            this.stateImages = new System.Windows.Forms.ImageList(this.components);
            this.mainMenu1 = new System.Windows.Forms.MainMenu(this.components);
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.mnuExit = new System.Windows.Forms.MenuItem();
            this.mnuAppearance = new System.Windows.Forms.MenuItem();
            this.mnuCheckBoxes = new System.Windows.Forms.MenuItem();
            this.menuItem15 = new System.Windows.Forms.MenuItem();
            this.mnuVisualStyle = new System.Windows.Forms.MenuItem();
            this.mnuClassic = new System.Windows.Forms.MenuItem();
            this.mnuXP = new System.Windows.Forms.MenuItem();
            this.mnuVista = new System.Windows.Forms.MenuItem();
            this.mnuThemed = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.menuItem3 = new System.Windows.Forms.MenuItem();
            this.menuItem7 = new System.Windows.Forms.MenuItem();
            this.menuItem5 = new System.Windows.Forms.MenuItem();
            this.menuItem8 = new System.Windows.Forms.MenuItem();
            this.menuItem4 = new System.Windows.Forms.MenuItem();
            this.mnuAllowEdit = new System.Windows.Forms.MenuItem();
            this.mnuDragDrop = new System.Windows.Forms.MenuItem();
            this.menuItem31 = new System.Windows.Forms.MenuItem();
            this.mnuAllowSelCheck = new System.Windows.Forms.MenuItem();
            this.mnuSelection = new System.Windows.Forms.MenuItem();
            this.menuItem6 = new System.Windows.Forms.MenuItem();
            this.menuItem9 = new System.Windows.Forms.MenuItem();
            this.menuItem10 = new System.Windows.Forms.MenuItem();
            this.menuItem12 = new System.Windows.Forms.MenuItem();
            this.mnuSelectAll = new System.Windows.Forms.MenuItem();
            this.menuItem13 = new System.Windows.Forms.MenuItem();
            this.mnuFading = new System.Windows.Forms.MenuItem();
            this.mnuFadingDefault = new System.Windows.Forms.MenuItem();
            this.mnuFadingOffice2007 = new System.Windows.Forms.MenuItem();
            this.menuItem14 = new System.Windows.Forms.MenuItem();
            this.menuItem16 = new System.Windows.Forms.MenuItem();
            this.menuItem17 = new System.Windows.Forms.MenuItem();
            this.menuItem18 = new System.Windows.Forms.MenuItem();
            this.menuItem19 = new System.Windows.Forms.MenuItem();
            this.menuItem21 = new System.Windows.Forms.MenuItem();
            this.menuItem23 = new System.Windows.Forms.MenuItem();
            this.mnuEncoding = new System.Windows.Forms.MenuItem();
            this.treeNodeImages = new System.Windows.Forms.ImageList(this.components);
            this.panel1 = new System.Windows.Forms.Panel();
            this.panel2 = new System.Windows.Forms.Panel();
            this.panel3 = new System.Windows.Forms.Panel();
            this.largeImages = new System.Windows.Forms.ImageList(this.components);
            this.treeView1 = new LidorSystems.IntegralUI.Lists.TreeView();
            this.mnuThreeState = new System.Windows.Forms.MenuItem();
            ((System.ComponentModel.ISupportInitialize)(this.treeView1)).BeginInit();
            this.SuspendLayout();
            // 
            // smallImages
            // 
            this.smallImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("smallImages.ImageStream")));
            this.smallImages.TransparentColor = System.Drawing.Color.Transparent;
            this.smallImages.Images.SetKeyName(0, "");
            this.smallImages.Images.SetKeyName(1, "");
            this.smallImages.Images.SetKeyName(2, "");
            this.smallImages.Images.SetKeyName(3, "");
            this.smallImages.Images.SetKeyName(4, "");
            this.smallImages.Images.SetKeyName(5, "");
            // 
            // stateImages
            // 
            this.stateImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("stateImages.ImageStream")));
            this.stateImages.TransparentColor = System.Drawing.Color.Transparent;
            this.stateImages.Images.SetKeyName(0, "");
            this.stateImages.Images.SetKeyName(1, "");
            this.stateImages.Images.SetKeyName(2, "");
            this.stateImages.Images.SetKeyName(3, "");
            this.stateImages.Images.SetKeyName(4, "");
            this.stateImages.Images.SetKeyName(5, "");
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem1,
            this.mnuAppearance,
            this.menuItem4,
            this.menuItem13,
            this.menuItem23});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuExit});
            this.menuItem1.Text = "File";
            // 
            // mnuExit
            // 
            this.mnuExit.Index = 0;
            this.mnuExit.Text = "Exit";
            this.mnuExit.Click += new System.EventHandler(this.mnuExit_Click);
            // 
            // mnuAppearance
            // 
            this.mnuAppearance.Index = 1;
            this.mnuAppearance.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuCheckBoxes,
            this.mnuThreeState,
            this.menuItem15,
            this.mnuVisualStyle,
            this.mnuThemed,
            this.menuItem2});
            this.mnuAppearance.Text = "Appearance";
            // 
            // mnuCheckBoxes
            // 
            this.mnuCheckBoxes.Index = 0;
            this.mnuCheckBoxes.Text = "Check boxes";
            this.mnuCheckBoxes.Click += new System.EventHandler(this.mnuCheckBoxes_Click);
            // 
            // menuItem15
            // 
            this.menuItem15.Index = 2;
            this.menuItem15.Text = "-";
            // 
            // mnuVisualStyle
            // 
            this.mnuVisualStyle.Index = 3;
            this.mnuVisualStyle.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuClassic,
            this.mnuXP,
            this.mnuVista});
            this.mnuVisualStyle.Text = "Visual Style";
            // 
            // mnuClassic
            // 
            this.mnuClassic.Index = 0;
            this.mnuClassic.Text = "Classic";
            this.mnuClassic.Click += new System.EventHandler(this.OnVisualStyleClick);
            // 
            // mnuXP
            // 
            this.mnuXP.Index = 1;
            this.mnuXP.Text = "XP";
            this.mnuXP.Click += new System.EventHandler(this.OnVisualStyleClick);
            // 
            // mnuVista
            // 
            this.mnuVista.Checked = true;
            this.mnuVista.Index = 2;
            this.mnuVista.Text = "Vista";
            this.mnuVista.Click += new System.EventHandler(this.OnVisualStyleClick);
            // 
            // mnuThemed
            // 
            this.mnuThemed.Checked = true;
            this.mnuThemed.Index = 4;
            this.mnuThemed.Text = "Themed";
            this.mnuThemed.Click += new System.EventHandler(this.mnuThemed_Click);
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 5;
            this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem3,
            this.menuItem7,
            this.menuItem5,
            this.menuItem8});
            this.menuItem2.Text = "HighlightType";
            // 
            // menuItem3
            // 
            this.menuItem3.Index = 0;
            this.menuItem3.RadioCheck = true;
            this.menuItem3.Text = "None";
            this.menuItem3.Click += new System.EventHandler(this.mnuHighlight_Click);
            // 
            // menuItem7
            // 
            this.menuItem7.Index = 1;
            this.menuItem7.RadioCheck = true;
            this.menuItem7.Text = "TextOnly";
            this.menuItem7.Click += new System.EventHandler(this.mnuHighlight_Click);
            // 
            // menuItem5
            // 
            this.menuItem5.Checked = true;
            this.menuItem5.Index = 2;
            this.menuItem5.RadioCheck = true;
            this.menuItem5.Text = "Partial";
            this.menuItem5.Click += new System.EventHandler(this.mnuHighlight_Click);
            // 
            // menuItem8
            // 
            this.menuItem8.Index = 3;
            this.menuItem8.RadioCheck = true;
            this.menuItem8.Text = "Full";
            this.menuItem8.Click += new System.EventHandler(this.mnuHighlight_Click);
            // 
            // menuItem4
            // 
            this.menuItem4.Index = 2;
            this.menuItem4.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuAllowEdit,
            this.mnuDragDrop,
            this.menuItem31,
            this.mnuAllowSelCheck,
            this.mnuSelection,
            this.mnuSelectAll});
            this.menuItem4.Text = "Behavior";
            // 
            // mnuAllowEdit
            // 
            this.mnuAllowEdit.Index = 0;
            this.mnuAllowEdit.Text = "Allow Label Edit";
            this.mnuAllowEdit.Click += new System.EventHandler(this.mnuAllowEdit_Click);
            // 
            // mnuDragDrop
            // 
            this.mnuDragDrop.Index = 1;
            this.mnuDragDrop.Text = "Allow Drag-Drop";
            this.mnuDragDrop.Click += new System.EventHandler(this.mnuDragDrop_Click);
            // 
            // menuItem31
            // 
            this.menuItem31.Index = 2;
            this.menuItem31.Text = "-";
            // 
            // mnuAllowSelCheck
            // 
            this.mnuAllowSelCheck.Index = 3;
            this.mnuAllowSelCheck.Text = "Allow Selection Check";
            this.mnuAllowSelCheck.Click += new System.EventHandler(this.mnuAllowSelCheck_Click);
            // 
            // mnuSelection
            // 
            this.mnuSelection.Index = 4;
            this.mnuSelection.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem6,
            this.menuItem9,
            this.menuItem10,
            this.menuItem12});
            this.mnuSelection.Text = "Selection";
            // 
            // menuItem6
            // 
            this.menuItem6.Index = 0;
            this.menuItem6.RadioCheck = true;
            this.menuItem6.Text = "None";
            this.menuItem6.Click += new System.EventHandler(this.mnuSelectionClick);
            // 
            // menuItem9
            // 
            this.menuItem9.Checked = true;
            this.menuItem9.Index = 1;
            this.menuItem9.RadioCheck = true;
            this.menuItem9.Text = "One";
            this.menuItem9.Click += new System.EventHandler(this.mnuSelectionClick);
            // 
            // menuItem10
            // 
            this.menuItem10.Index = 2;
            this.menuItem10.RadioCheck = true;
            this.menuItem10.Text = "Multi Simple";
            this.menuItem10.Click += new System.EventHandler(this.mnuSelectionClick);
            // 
            // menuItem12
            // 
            this.menuItem12.Index = 3;
            this.menuItem12.RadioCheck = true;
            this.menuItem12.Text = "Multi Extended";
            this.menuItem12.Click += new System.EventHandler(this.mnuSelectionClick);
            // 
            // mnuSelectAll
            // 
            this.mnuSelectAll.Enabled = false;
            this.mnuSelectAll.Index = 5;
            this.mnuSelectAll.Text = "Select All";
            this.mnuSelectAll.Click += new System.EventHandler(this.mnuSelectAll_Click);
            // 
            // menuItem13
            // 
            this.menuItem13.Index = 3;
            this.menuItem13.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuFading,
            this.menuItem14});
            this.menuItem13.Text = "Fading";
            // 
            // mnuFading
            // 
            this.mnuFading.Index = 0;
            this.mnuFading.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuFadingDefault,
            this.mnuFadingOffice2007});
            this.mnuFading.Text = "Effect";
            // 
            // mnuFadingDefault
            // 
            this.mnuFadingDefault.Checked = true;
            this.mnuFadingDefault.Index = 0;
            this.mnuFadingDefault.RadioCheck = true;
            this.mnuFadingDefault.Text = "Default";
            this.mnuFadingDefault.Click += new System.EventHandler(this.mnuFadingEffectClick);
            // 
            // mnuFadingOffice2007
            // 
            this.mnuFadingOffice2007.Index = 1;
            this.mnuFadingOffice2007.RadioCheck = true;
            this.mnuFadingOffice2007.Text = "Office 2007";
            this.mnuFadingOffice2007.Click += new System.EventHandler(this.mnuFadingEffectClick);
            // 
            // menuItem14
            // 
            this.menuItem14.Index = 1;
            this.menuItem14.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem16,
            this.menuItem17,
            this.menuItem18,
            this.menuItem19,
            this.menuItem21});
            this.menuItem14.Text = "Speed";
            // 
            // menuItem16
            // 
            this.menuItem16.Index = 0;
            this.menuItem16.RadioCheck = true;
            this.menuItem16.Text = "Very Slow";
            this.menuItem16.Click += new System.EventHandler(this.mnuFadingSpeedClick);
            // 
            // menuItem17
            // 
            this.menuItem17.Index = 1;
            this.menuItem17.RadioCheck = true;
            this.menuItem17.Text = "Slow";
            this.menuItem17.Click += new System.EventHandler(this.mnuFadingSpeedClick);
            // 
            // menuItem18
            // 
            this.menuItem18.Checked = true;
            this.menuItem18.Index = 2;
            this.menuItem18.RadioCheck = true;
            this.menuItem18.Text = "Normal";
            this.menuItem18.Click += new System.EventHandler(this.mnuFadingSpeedClick);
            // 
            // menuItem19
            // 
            this.menuItem19.Index = 3;
            this.menuItem19.RadioCheck = true;
            this.menuItem19.Text = "Fast";
            this.menuItem19.Click += new System.EventHandler(this.mnuFadingSpeedClick);
            // 
            // menuItem21
            // 
            this.menuItem21.Index = 4;
            this.menuItem21.RadioCheck = true;
            this.menuItem21.Text = "Very Fast";
            this.menuItem21.Click += new System.EventHandler(this.mnuFadingSpeedClick);
            // 
            // menuItem23
            // 
            this.menuItem23.Index = 4;
            this.menuItem23.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuEncoding});
            this.menuItem23.Text = "XML Encoding";
            // 
            // mnuEncoding
            // 
            this.mnuEncoding.Index = 0;
            this.mnuEncoding.Text = "Show Encoding";
            this.mnuEncoding.Click += new System.EventHandler(this.mnuEncoding_Click);
            // 
            // treeNodeImages
            // 
            this.treeNodeImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("treeNodeImages.ImageStream")));
            this.treeNodeImages.TransparentColor = System.Drawing.Color.Transparent;
            this.treeNodeImages.Images.SetKeyName(0, "");
            this.treeNodeImages.Images.SetKeyName(1, "");
            this.treeNodeImages.Images.SetKeyName(2, "");
            // 
            // panel1
            // 
            this.panel1.Dock = System.Windows.Forms.DockStyle.Left;
            this.panel1.Location = new System.Drawing.Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(2, 311);
            this.panel1.TabIndex = 3;
            // 
            // panel2
            // 
            this.panel2.Dock = System.Windows.Forms.DockStyle.Right;
            this.panel2.Location = new System.Drawing.Point(468, 0);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size(2, 311);
            this.panel2.TabIndex = 5;
            // 
            // panel3
            // 
            this.panel3.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.panel3.Location = new System.Drawing.Point(2, 309);
            this.panel3.Name = "panel3";
            this.panel3.Size = new System.Drawing.Size(466, 2);
            this.panel3.TabIndex = 7;
            // 
            // largeImages
            // 
            this.largeImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("largeImages.ImageStream")));
            this.largeImages.TransparentColor = System.Drawing.Color.Transparent;
            this.largeImages.Images.SetKeyName(0, "");
            this.largeImages.Images.SetKeyName(1, "");
            this.largeImages.Images.SetKeyName(2, "");
            // 
            // treeView1
            // 
            // 
            // 
            // 
            this.treeView1.ContentPanel.BackColor = System.Drawing.Color.Transparent;
            this.treeView1.ContentPanel.Location = new System.Drawing.Point(3, 3);
            this.treeView1.ContentPanel.Name = "";
            this.treeView1.ContentPanel.Size = new System.Drawing.Size(460, 303);
            this.treeView1.ContentPanel.TabIndex = 3;
            this.treeView1.ContentPanel.TabStop = false;
            this.treeView1.Cursor = System.Windows.Forms.Cursors.Default;
            this.treeView1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.treeView1.ImageIndex = 0;
            this.treeView1.ImageList = this.smallImages;
            this.treeView1.ItemHighlightType = LidorSystems.IntegralUI.Lists.ListItemHighlightType.Partial;
            this.treeView1.Location = new System.Drawing.Point(2, 0);
            this.treeView1.Name = "treeView1";
            listItemFormatStyle1.Padding = new System.Windows.Forms.Padding(2, 1, 2, 1);
            this.treeView1.NodeFormatStyle = listItemFormatStyle1;
            this.treeView1.SelectedImageIndex = 1;
            this.treeView1.Size = new System.Drawing.Size(466, 309);
            this.treeView1.StateImageList = this.stateImages;
            this.treeView1.TabIndex = 0;
            this.treeView1.Text = "treeView1";
            this.treeView1.UseTheme = true;
            this.treeView1.WatermarkImage = watermarkImage1;
            this.treeView1.AfterCollapse += new LidorSystems.IntegralUI.ObjectEventHandler(this.treeView1_AfterCollapse);
            this.treeView1.BeforeExpand += new LidorSystems.IntegralUI.ObjectCancelEventHandler(this.treeView1_BeforeExpand);
            // 
            // mnuThreeState
            // 
            this.mnuThreeState.Index = 1;
            this.mnuThreeState.Text = "CheckBox ThreeState";
            this.mnuThreeState.Click += new System.EventHandler(this.mnuThreeState_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(470, 311);
            this.Controls.Add(this.treeView1);
            this.Controls.Add(this.panel3);
            this.Controls.Add(this.panel2);
            this.Controls.Add(this.panel1);
            this.Menu = this.mainMenu1;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "IntegralUI TreeView Explorer";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.treeView1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		#region Methods

		#region General
		private String GetAttributeString(FileAttributes attributes)
		{
			String retValue = "";

			if ((attributes & FileAttributes.ReadOnly) > 0)
				retValue += "R";
			if ((attributes & FileAttributes.System) > 0)
				retValue += "S";
			if ((attributes & FileAttributes.Hidden) > 0)
				retValue += "H";
			if ((attributes & FileAttributes.Archive) > 0)
				retValue += "A";
			if ((attributes & FileAttributes.Compressed) > 0)
				retValue += "C";

			return retValue;
		}

		private int GetFileSize(FileInfo fi)
		{
			int fileSize = (int)(fi.Length/1024);
			if (fi.Length % 1024 != 0)
				return (fileSize+1);
			else
				return fileSize;
		}

		private int GetStateImageIndex(FileAttributes attributes)
		{
			switch (attributes)
			{
				case FileAttributes.Archive:
					return 0;
				case FileAttributes.Directory:
					return 1;
				case FileAttributes.ReadOnly | FileAttributes.Directory:
					return 2;
//				case FileAttributes.NotContentIndexed | FileAttributes.Directory:
//					return 3;
				case FileAttributes.Hidden | FileAttributes.System | FileAttributes.Directory:
					return 4;
				case FileAttributes.ReadOnly | FileAttributes.Hidden | FileAttributes.Directory:
					return 5;
			}

			return -1;
		}
		#endregion

		#region Initialization
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			InitializeTreeView();
		}
		#endregion

		#region Menus

		#region Appearance
		private void mnuCheckBoxes_Click(object sender, System.EventArgs e)
		{
			mnuCheckBoxes.Checked = !mnuCheckBoxes.Checked;

			this.treeView1.CheckBoxes = mnuCheckBoxes.Checked;
		}

        private void mnuThreeState_Click(object sender, EventArgs e)
        {
            mnuThreeState.Checked = !mnuThreeState.Checked;

            if (mnuThreeState.Checked)
                this.treeView1.CheckMode = LidorSystems.IntegralUI.CheckMode.ThreeState;
            else
                this.treeView1.CheckMode = LidorSystems.IntegralUI.CheckMode.TwoState;
        }

		private void mnuHighlight_Click(object sender, System.EventArgs e)
		{
			if (sender is MenuItem)
			{
				MenuItem mi = (MenuItem)sender;

				switch (mi.Index)
				{
					case 0:
						this.treeView1.ItemHighlightType = LidorSystems.IntegralUI.Lists.ListItemHighlightType.None;
						break;

					case 1:
                        this.treeView1.ItemHighlightType = LidorSystems.IntegralUI.Lists.ListItemHighlightType.TextOnly;
						break;

					case 3:
                        this.treeView1.ItemHighlightType = LidorSystems.IntegralUI.Lists.ListItemHighlightType.Full;
						break;

					default:
                        this.treeView1.ItemHighlightType = LidorSystems.IntegralUI.Lists.ListItemHighlightType.Partial;
						break;
				}

				for (int i = 0; i < mi.Parent.MenuItems.Count; i++)
					mi.Parent.MenuItems[i].Checked = false;

				mi.Checked = true;
			}
		}

		private void OnVisualStyleClick(object sender, System.EventArgs e)
		{
			if (sender is MenuItem)
			{
				MenuItem mi = (MenuItem)sender;

				switch (mi.Index)
				{
					case 0:
						this.treeView1.VisualStyle = VisualStyle.Classic;
						break;

					case 1:
						this.treeView1.VisualStyle = VisualStyle.XP;
						break;

					default:
						this.treeView1.VisualStyle = VisualStyle.Vista;
						break;
				}

				for (int i = 0; i < mi.Parent.MenuItems.Count; i++)
					mi.Parent.MenuItems[i].Checked = false;

				mi.Checked = true;
			}
		}

		private void mnuThemed_Click(object sender, System.EventArgs e)
		{
			mnuThemed.Checked = !mnuThemed.Checked;	

			this.treeView1.UseTheme = mnuThemed.Checked;
		}
		#endregion

		#region Behavior
		private void mnuAllowEdit_Click(object sender, System.EventArgs e)
		{
			mnuAllowEdit.Checked = !mnuAllowEdit.Checked;

			this.treeView1.LabelEdit = mnuAllowEdit.Checked;
		}

		private void mnuDragDrop_Click(object sender, System.EventArgs e)
		{
			mnuDragDrop.Checked = !mnuDragDrop.Checked;

			this.treeView1.AllowDrag = mnuDragDrop.Checked;
			this.treeView1.AllowDrop = mnuDragDrop.Checked;
		}

		private void mnuAllowSelCheck_Click(object sender, System.EventArgs e)
		{
			mnuAllowSelCheck.Checked = !mnuAllowSelCheck.Checked;

			this.treeView1.AllowSelectionCheck = mnuAllowSelCheck.Checked;
		}

		private void mnuSelectionClick(object sender, System.EventArgs e)
		{
			if (sender is MenuItem)
			{
				MenuItem mi = (MenuItem)sender;

				for (int i = 0; i < mi.Parent.MenuItems.Count; i++)
					mi.Parent.MenuItems[i].Checked = false;

				mi.Checked = true;

				SelectionMode selMode = SelectionMode.One;
				switch (mi.Index)
				{
					case 0:
						selMode = SelectionMode.None;
						mnuSelectAll.Enabled = false;
						break;
					case 2:
						selMode = SelectionMode.MultiSimple;
						mnuSelectAll.Enabled = true;
						break;
					case 3:
						selMode = SelectionMode.MultiExtended;
						mnuSelectAll.Enabled = true;
						break;
					default:
						selMode = SelectionMode.One;
						mnuSelectAll.Enabled = false;
						break;
				}

				this.treeView1.SelectionMode = selMode;
			}
		}

		private void mnuSelectAll_Click(object sender, System.EventArgs e)
		{
			this.treeView1.SuspendPaint();
			foreach (LidorSystems.IntegralUI.Lists.TreeNode node in this.treeView1.Nodes)
				SelectAllNodes(node);
			this.treeView1.ResumePaint();
		}

		private void SelectAllNodes(LidorSystems.IntegralUI.Lists.TreeNode parentNode)
		{
			parentNode.Selected = true;

			foreach (LidorSystems.IntegralUI.Lists.TreeNode node in parentNode.Nodes)
				SelectAllNodes(node);
		}
		#endregion

		#region Fading
		private void mnuFadingEffectClick(object sender, System.EventArgs e)
		{
			if (sender is MenuItem)
			{
				MenuItem mi = (MenuItem)sender;

				for (int i = 0; i < mi.Parent.MenuItems.Count; i++)
					mi.Parent.MenuItems[i].Checked = false;

				mi.Checked = true;

				if (mi.Index == 0)
					this.treeView1.FadingEffect = LidorSystems.IntegralUI.FadingEffect.Default;
				else
					this.treeView1.FadingEffect = LidorSystems.IntegralUI.FadingEffect.Office2007;
			}
		}

		private void mnuFadingSpeedClick(object sender, System.EventArgs e)
		{
			if (sender is MenuItem)
			{
				MenuItem mi = (MenuItem)sender;

				for (int i = 0; i < mi.Parent.MenuItems.Count; i++)
					mi.Parent.MenuItems[i].Checked = false;

				mi.Checked = true;

				LidorSystems.IntegralUI.FadingSpeed speed = LidorSystems.IntegralUI.FadingSpeed.Normal;
				switch (mi.Index)
				{
					case 0:
						speed = LidorSystems.IntegralUI.FadingSpeed.VerySlow;
						break;
					case 1:
						speed = LidorSystems.IntegralUI.FadingSpeed.Slow;
						break;
					case 3:
						speed = LidorSystems.IntegralUI.FadingSpeed.Fast;
						break;
					case 4:
						speed = LidorSystems.IntegralUI.FadingSpeed.VeryFast;
						break;
				}

				this.treeView1.FadingSpeed = speed;
			}
		}
		#endregion

		#region File
		private void mnuExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
		#endregion

		#region XML
		private void mnuEncoding_Click(object sender, System.EventArgs e)
		{
			mnuEncoding.Checked = !mnuEncoding.Checked;

			this.treeView1.SuspendUpdate();

			if (mnuEncoding.Checked)
			{
				this.treeView1.ImageList = this.largeImages;
                this.treeView1.NodeFormatStyle.Padding = new System.Windows.Forms.Padding(2, 4, 2, 4);
				this.treeView1.NodeFormatStyle.TextRendering = System.Drawing.Text.TextRenderingHint.AntiAlias;
			}
			else
			{
				this.treeView1.ImageList = this.smallImages;
                this.treeView1.NodeFormatStyle.Padding = new System.Windows.Forms.Padding(2, 1, 2, 1);
				this.treeView1.NodeFormatStyle.TextRendering = System.Drawing.Text.TextRenderingHint.SystemDefault;
			}

			InitializeTreeView();

			this.treeView1.ResumeUpdate();
		}
		#endregion

		#endregion

		#region TreeView
		private void InitializeTreeView()
		{
			DirectoryInfo di = new DirectoryInfo("C:\\Program Files");
			if (di.Exists)
			{
				this.treeView1.SuspendUpdate();
				this.treeView1.Nodes.Clear();

				foreach (DirectoryInfo childDirectory in di.GetDirectories())
				{
					if (childDirectory.Name != "System Volume Information")
						LoadDirectoryInTreeView(null, childDirectory);
				}

				foreach (FileInfo childDFile in di.GetFiles())
					LoadFileInTreeView(null, childDFile);

				this.treeView1.ResumeUpdate();

				if (this.treeView1.Nodes.Count > 0)
				{
					this.treeView1.SelectedNode = this.treeView1.Nodes[0];
					this.treeView1.SelectedNode.EnsureVisible();
				}
			}
			else
				MessageBox.Show("The specified directory doesn't exist", "IntegralUI Lists Demo", MessageBoxButtons.OK, MessageBoxIcon.Error);
		}

		private void LoadDirectoryInTreeView(LidorSystems.IntegralUI.Lists.TreeNode parentNode, DirectoryInfo di)
		{
			LidorSystems.IntegralUI.Lists.TreeNode node = new LidorSystems.IntegralUI.Lists.TreeNode(di.Name);
			node.Tag = di;
			node.CheckBoxVisible = true;
			node.StateImageIndex = GetStateImageIndex(di.Attributes);

			if (mnuEncoding.Checked)
			{
                node.Content = "<div><p><b><font color=\"#006E12\">" + di.Name + "</font></b> - ";
                node.Content += "<font color=\"#0066CC\">File Folder</font></p>";
                node.Content += "<p style=\"textcolor:Gray\">Folders <font color=\"Black\">" + di.GetDirectories().Length.ToString() + "</font>, Files <font color=\"Black\">" + di.GetFiles().Length.ToString() + "</font></p></div>";
            }

			if (di.GetDirectories().Length > 0)
				node.Nodes.Add(new LidorSystems.IntegralUI.Lists.TreeNode("Empty"));

			if (parentNode != null)
				parentNode.Nodes.Add(node);
			else
				this.treeView1.Nodes.Add(node);
		}

		private void LoadFileInTreeView(LidorSystems.IntegralUI.Lists.TreeNode parentNode, FileInfo fi)
		{
			LidorSystems.IntegralUI.Lists.TreeNode node = new LidorSystems.IntegralUI.Lists.TreeNode(fi.Name);
			node.Tag = fi;
			node.CheckBoxVisible = true;
			node.ImageIndex = 2;
			node.SelectedImageIndex = 2;
			node.StateImageIndex = GetStateImageIndex(fi.Attributes);

			if (mnuEncoding.Checked)
			{
                node.Content = "<div><p fontsize=\"10\"><font color=\"#E17600\">" + fi.Name + "</font> - ";
                node.Content += "<font color=\"#0066CC\">File</font></p>";
                node.Content += "<p style=\"textcolor:Gray\">" + GetFileSize(fi).ToString() + " KB</p></div>";
            }

			if (parentNode != null)
				parentNode.Nodes.Add(node);
			else
				this.treeView1.Nodes.Add(node);
		}

		private void treeView1_BeforeExpand(object sender, LidorSystems.IntegralUI.ObjectCancelEventArgs e)
		{
			if (e.Object is LidorSystems.IntegralUI.Lists.TreeNode)
			{
				LidorSystems.IntegralUI.Lists.TreeNode node = (LidorSystems.IntegralUI.Lists.TreeNode)e.Object;

				this.treeView1.SuspendUpdate();
				node.Nodes.Clear();
				if (node.Tag is DirectoryInfo)
				{
					DirectoryInfo di = (DirectoryInfo)node.Tag;
					foreach (DirectoryInfo childDirectory in di.GetDirectories())
						LoadDirectoryInTreeView(node, childDirectory);

					foreach (FileInfo childDFile in di.GetFiles())
						LoadFileInTreeView(node, childDFile);
				}
				this.treeView1.ResumeUpdate();
			}
		}

		private void treeView1_AfterCollapse(object sender, LidorSystems.IntegralUI.ObjectEventArgs e)
		{
			if (e.Object is LidorSystems.IntegralUI.Lists.TreeNode)
			{
				LidorSystems.IntegralUI.Lists.TreeNode node = (LidorSystems.IntegralUI.Lists.TreeNode)e.Object;

				this.treeView1.SuspendUpdate();

				node.Nodes.Clear();
				node.Nodes.Add(new LidorSystems.IntegralUI.Lists.TreeNode("Empty"));

				this.treeView1.ResumeUpdate();
			}
		}
		#endregion

		#endregion
	}
	#endregion
}
